/* LED counter GNOME panel applet
 * Insprired by Sixtyfour bit counter by Tim Gerla
 * and xled by Jan Schoenepauck <schoenep@uni-wuppertal.de>
 * and Joachim Gassen <gassen@uni-muenster.de>"
 *
 * By Uwe Steinmann <Uwe.Steinmann@fernuni-hagen.de>
 *
 * Enjoy.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or 
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License  
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <gnome.h>
#include <applet-widget.h>
#include "gtkdisplay.h"
#include "ledcount.h"

extern DISP_INFO disp_info[MAX_DISPLAYS];
extern int height, width;
extern int displays;
extern int new_displays;
extern int spacing;
extern GdkColor on, off, over;
extern gchar con_s[32], coff_s[32], cover_s[32];
extern int count_timer(GtkWidget *data);
extern void add_exec_button(DISP_INFO *disp_info);
extern void remove_exec_button(DISP_INFO *disp_info);

static GtkWidget *pb;

static void toggle_autorange(GtkWidget *widget, void *data)
{
	char buffer[50];

	GtkWidget *w;
	GnomePropertyBox *box = GNOME_PROPERTY_BOX (pb);
	sprintf(buffer, "digits%d", (int) data);
	w = gtk_object_get_data(GTK_OBJECT(box), buffer);
	if(GTK_TOGGLE_BUTTON(widget)->active) {
		gtk_widget_set_sensitive(GTK_WIDGET(w), FALSE);
	} else {
		gtk_widget_set_sensitive(GTK_WIDGET(w), TRUE);
	}
	gnome_property_box_changed(GNOME_PROPERTY_BOX(pb));
}

static void toggle_countmode(GtkWidget *widget, void *data)
{
	char buffer[50];

	GtkWidget *w, *w1, *w2;
	GnomePropertyBox *box = GNOME_PROPERTY_BOX (pb);
	sprintf(buffer, "mailboxbox%d", (int) data);
	w = gtk_object_get_data(GTK_OBJECT(box), buffer);
	sprintf(buffer, "countmodeframe%d", (int) data);
	w1 = gtk_object_get_data(GTK_OBJECT(box), buffer);
	sprintf(buffer, "backend%d", (int) data);
	w2 = gtk_object_get_data(GTK_OBJECT(box), buffer);
	if(GTK_TOGGLE_BUTTON(widget)->active) {
		gtk_widget_set_sensitive(GTK_WIDGET(w), TRUE);
		gtk_widget_set_sensitive(GTK_WIDGET(w1), TRUE);
		gtk_widget_set_sensitive(GTK_WIDGET(w2), FALSE);
	} else {
		gtk_widget_set_sensitive(GTK_WIDGET(w), FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(w1), FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(w2), TRUE);
	}
	gnome_property_box_changed(GNOME_PROPERTY_BOX(pb));
}

static void apply_cb(GtkObject *pb, gpointer p)
{
	guint8 r1, g1, b1, r2, g2, b2;
	int i, itmp;
	char *buf;

	GnomeColorPicker *con = gtk_object_get_data(pb, "con");
	GnomeColorPicker *coff= gtk_object_get_data(pb, "coff");
	GnomeColorPicker *cover= gtk_object_get_data(pb, "cover");
	GtkWidget *width_s = gtk_object_get_data(GTK_OBJECT(pb),"width");
	GtkWidget *height_s = gtk_object_get_data(GTK_OBJECT(pb),"height");
	GtkWidget *displays_s = gtk_object_get_data(GTK_OBJECT(pb), "displays");
	GtkWidget *spacing_s = gtk_object_get_data(GTK_OBJECT(pb), "spacing");

	buf = gtk_entry_get_text(GTK_ENTRY(height_s));
	sscanf(buf, "%d", &height);
	buf = gtk_entry_get_text(GTK_ENTRY(width_s));
	sscanf(buf, "%d", &width);
	buf = gtk_entry_get_text(GTK_ENTRY(displays_s));
	sscanf(buf, "%d", &new_displays);
	buf = gtk_entry_get_text(GTK_ENTRY(spacing_s));
	sscanf(buf, "%d", &spacing);

	for(i=0; i<displays; i++) {
		GtkWidget *mailbox_s;
		char buffer[256];

		/**** Mailbox ****/
		sprintf(buffer, "mailbox%d", i+1);
		mailbox_s = gtk_object_get_data(GTK_OBJECT(pb), buffer);
		if(disp_info[i].mailbox_file) {
			free(disp_info[i].mailbox_file);
			disp_info[i].mailbox_file = NULL;
		}
		disp_info[i].mailbox_file = strdup(gtk_entry_get_text(GTK_ENTRY(mailbox_s)));

		/**** Execute if button is pressed ****/
		sprintf(buffer, "exec%d", i+1);
		mailbox_s = gtk_object_get_data(GTK_OBJECT(pb), buffer);
		if(disp_info[i].exec_command) {
			free(disp_info[i].exec_command);
		}
		disp_info[i].exec_command = strdup(gtk_entry_get_text(GTK_ENTRY(mailbox_s)));

		/**** Title ****/
		sprintf(buffer, "title%d", i+1);
		mailbox_s = gtk_object_get_data(GTK_OBJECT(pb), buffer);
		if(disp_info[i].title) {
			free(disp_info[i].title);
		}
		disp_info[i].title = strdup(gtk_entry_get_text(GTK_ENTRY(mailbox_s)));
		if(disp_info[i].exec_button)
			gtk_label_set(GTK_LABEL(disp_info[i].label), disp_info[i].title);

		/**** Command to count something ****/
		sprintf(buffer, "backend%d", i+1);
		mailbox_s = gtk_object_get_data(GTK_OBJECT(pb), buffer);
		if(disp_info[i].backend_command) {
			free(disp_info[i].backend_command);
		}
		disp_info[i].backend_command = strdup(gtk_entry_get_text(GTK_ENTRY(mailbox_s)));

		/**** Counter mode (Mail/Kommand) ****/
		sprintf(buffer, "mailmode%d", i+1);
		mailbox_s = gtk_object_get_data(GTK_OBJECT(pb), buffer);
		disp_info[i].mail_mode = GTK_TOGGLE_BUTTON(mailbox_s)->active ? 1 : 0;
		disp_info[i].front_end_mode = GTK_TOGGLE_BUTTON(mailbox_s)->active ? 0 : 1;

		/**** Show unread/all messages ****/
		sprintf(buffer, "unreadmessages%d", i+1);
		mailbox_s = gtk_object_get_data(GTK_OBJECT(pb), buffer);
		disp_info[i].show_all_messages = GTK_TOGGLE_BUTTON(mailbox_s)->active ? 0 : 1;

		/**** Autorange on/off ****/
		sprintf(buffer, "autorange%d", i+1);
		mailbox_s = gtk_object_get_data(GTK_OBJECT(pb), buffer);
		disp_info[i].autodigits = GTK_TOGGLE_BUTTON(mailbox_s)->active ? 1 : 0;
		gtk_display_set_autorange(GTK_DISPLAY(disp_info[i].display), disp_info[i].autodigits);

		/**** button on/off ****/
		sprintf(buffer, "execbutton%d", i+1);
		mailbox_s = gtk_object_get_data(GTK_OBJECT(pb), buffer);
		itmp = GTK_TOGGLE_BUTTON(mailbox_s)->active ? 1 : 0;
		if(itmp != disp_info[i].exec_button) {
			if(itmp)
				add_exec_button(&disp_info[i]);
			else
				remove_exec_button(&disp_info[i]);
			disp_info[i].exec_button = itmp;
		}

		/**** Number of digits *****/
		sprintf(buffer, "digits%d", i+1);
		mailbox_s = gtk_object_get_data(GTK_OBJECT(pb), buffer);
		buf = gtk_entry_get_text(GTK_ENTRY(mailbox_s));
		sscanf(buf, "%d", &disp_info[i].digits);
		if(disp_info[i].autodigits == 0) {
			gtk_display_set_digits(GTK_DISPLAY(disp_info[i].display), disp_info[i].digits);
		}

		/**** Renew timeout for this display *****/
		sprintf(buffer, "update%d", i+1);
		mailbox_s = gtk_object_get_data(GTK_OBJECT(pb), buffer);
		buf = gtk_entry_get_text(GTK_ENTRY(mailbox_s));
		sscanf(buf, "%d", &disp_info[i].updatetime);
		gtk_timeout_remove(disp_info[i].timeout);
		disp_info[i].timeout = gtk_timeout_add(disp_info[i].updatetime, (GtkFunction)count_timer, (void *) i+1);

		/**** Correct size of display depending of button ****/
		if(disp_info[i].exec_button)
			gtk_widget_set_usize(disp_info[i].display,
			  width*gtk_display_get_digits(GTK_DISPLAY(disp_info[i].display)),
			  height);
		else
			gtk_widget_set_usize(disp_info[i].display,
			  width*gtk_display_get_digits(GTK_DISPLAY(disp_info[i].display)),
			  height+BUTTON_HEIGHT);

	}

	/**** Set colors ****/
	gnome_color_picker_get_i8(con,  &r1, &g1, &b1, NULL);
	g_snprintf(con_s, 31, "#%02X%02X%02X", r1, g1, b1);

	gnome_color_picker_get_i8(coff, &r2, &g2, &b2, NULL);
	g_snprintf(coff_s, 31, "#%02X%02X%02X", r2, g2, b2);
	
	gnome_color_picker_get_i8(cover, &r2, &g2, &b2, NULL);
	g_snprintf(cover_s, 31, "#%02X%02X%02X", r2, g2, b2);

	gdk_color_parse(con_s, &on);
	gdk_color_parse(coff_s, &off);
	gdk_color_parse(cover_s, &over);

	for(i = 0; i < displays; i++)
		gtk_display_set_colors(GTK_DISPLAY(disp_info[i].display), &on, &off, &over);

	/**** Update all counters ****/
	count_timer(NULL);

	/**** Change spacing ****/
	change_spacing(spacing);

}

static void
changed_cb(GtkWidget *w, GtkWidget *d)
{	
	gnome_property_box_changed(GNOME_PROPERTY_BOX(pb));
}

void
prefs_cb(GtkWidget *w, gpointer p)
{
	GtkWidget *table, *radio_table, *mail_table, *t_button, *b_button, *frame;
	GtkWidget *label, *heightw, *widthw, *con, *coff, *cover, *displays2, *update, *ww, *box, *checkbox;
	GtkAdjustment *adj;
	int i, fr, fg, fb;

	pb = gnome_property_box_new();
	gtk_window_set_title(GTK_WINDOW(pb), _("Counter Properties"));
	
	table = gtk_table_new(8, 3, FALSE);

	/* On color */
	label = gtk_label_new(_("LED on color"));
	con = gnome_color_picker_new();
	sscanf( con_s, "#%02x%02x%02x", &fr,&fg,&fb );
	gnome_color_picker_set_i8(GNOME_COLOR_PICKER(con),
	                           fr,
	                           fg,
	                           fb,
	                           255);
	gtk_object_set_data(GTK_OBJECT(pb), "con", con);
	gtk_signal_connect(GTK_OBJECT(con), "color_set",
			   GTK_SIGNAL_FUNC(changed_cb), pb);

	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 2, 0, 1);
	gtk_table_attach_defaults(GTK_TABLE(table), con, 2, 3, 0, 1);

	/* off color */
	label = gtk_label_new(_("LED off color"));
	coff = gnome_color_picker_new();
	sscanf( coff_s, "#%02x%02x%02x", &fr,&fg,&fb );
	gnome_color_picker_set_i8(GNOME_COLOR_PICKER(coff),
	                           fr,
	                           fg,
	                           fb,
	                           255);
	gtk_object_set_data(GTK_OBJECT(pb), "coff", coff);
	gtk_signal_connect(GTK_OBJECT(coff), "color_set",
			   GTK_SIGNAL_FUNC(changed_cb), pb);

	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 2, 1, 2);
	gtk_table_attach_defaults(GTK_TABLE(table), coff,  2, 3, 1, 2);
	
	/* Over color */
	label = gtk_label_new(_("Overflow color"));
	cover = gnome_color_picker_new();
	sscanf( cover_s, "#%02x%02x%02x", &fr,&fg,&fb );
	gnome_color_picker_set_i8(GNOME_COLOR_PICKER(cover),
	                           fr,
	                           fg,
	                           fb,
	                           255);
	gtk_object_set_data(GTK_OBJECT(pb), "cover", cover);
	gtk_signal_connect(GTK_OBJECT(cover), "color_set",
			   GTK_SIGNAL_FUNC(changed_cb), pb);

	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 2, 2, 3);
	gtk_table_attach_defaults(GTK_TABLE(table), cover, 2, 3, 2, 3);

	/* height */
	label = gtk_label_new(_("Digit height"));
	adj = (GtkAdjustment *) gtk_adjustment_new(0, 15, 100, 1, 10, 0);
	gtk_adjustment_set_value(adj, height);
	heightw = gtk_spin_button_new(adj, 0, 0);
	gtk_object_set_data(GTK_OBJECT(pb), "height", heightw);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 2, 3, 4);
	gtk_table_attach_defaults(GTK_TABLE(table), heightw,  2, 3, 3, 4);

	gtk_signal_connect(GTK_OBJECT(heightw), "changed",
			   GTK_SIGNAL_FUNC(changed_cb), NULL);

	/* Width */
	label = gtk_label_new(_("Digit width"));
	adj = (GtkAdjustment *) gtk_adjustment_new(0, 15, 100, 1, 10, 0);
	gtk_adjustment_set_value(adj, width);
	widthw = gtk_spin_button_new(adj, 0, 0);
	gtk_object_set_data(GTK_OBJECT(pb), "width", widthw);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 2, 4, 5);
	gtk_table_attach_defaults(GTK_TABLE(table), widthw,  2, 3, 4, 5);

	gtk_signal_connect(GTK_OBJECT(widthw), "changed",
			   GTK_SIGNAL_FUNC(changed_cb), NULL);

	gnome_property_box_append_page(GNOME_PROPERTY_BOX(pb), table,
				       gtk_label_new(_("General")));

	/* number of displays */
	label = gtk_label_new(_("Number of counters"));
	adj = (GtkAdjustment *) gtk_adjustment_new(0, 1, MAX_DISPLAYS, 1, 1, 0);
	gtk_adjustment_set_value(adj, new_displays);
	displays2 = gtk_spin_button_new(adj, 0, 0);
	gtk_object_set_data(GTK_OBJECT(pb), "displays", displays2);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 2, 5, 6);
	gtk_table_attach_defaults(GTK_TABLE(table), displays2,  2, 3, 5, 6);

	gtk_signal_connect(GTK_OBJECT(displays2), "changed",
	                   GTK_SIGNAL_FUNC(changed_cb), NULL);
	gtk_signal_connect(GTK_OBJECT(adj), "value_changed",
	                   GTK_SIGNAL_FUNC(changed_cb), NULL);

	/* spacing */
	adj = (GtkAdjustment *) gtk_adjustment_new(0, 0, 100, 1, 10, 0);
	gtk_adjustment_set_value(adj, spacing);
	label = gtk_label_new(_("Space between counters"));
	update = gtk_spin_button_new(adj, 0, 0);
	gtk_object_set_data(GTK_OBJECT(pb), "spacing", update);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 2, 7, 8);
	gtk_table_attach_defaults(GTK_TABLE(table), update,  2, 3, 7, 8);

	gtk_signal_connect(GTK_OBJECT(adj), "changed",
	                   GTK_SIGNAL_FUNC(changed_cb), NULL);
	gtk_signal_connect(GTK_OBJECT(adj), "value_changed",
	                   GTK_SIGNAL_FUNC(changed_cb), NULL);

	for(i=0; i<displays; i++) {
		char buffer[40];
		GtkWidget *mail_filename, *entry;
		mail_table = gtk_table_new(9, 3, FALSE);

		label = gtk_label_new(_("Title"));
		entry = gtk_entry_new();
		gtk_entry_set_text(GTK_ENTRY(entry), (gchar *) disp_info[i].title);
		sprintf(buffer, "title%d", i+1);
		gtk_object_set_data(GTK_OBJECT(pb), buffer, entry);
		gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, 0, 1);
		gtk_table_attach_defaults(GTK_TABLE(mail_table), entry,  1, 3, 0, 1);
		gtk_signal_connect(GTK_OBJECT(entry), "changed",
			   GTK_SIGNAL_FUNC(changed_cb), pb);

		label = gtk_label_new(_("Mailbox"));
		box = gtk_hbox_new(FALSE,GNOME_PAD_SMALL);
		sprintf(buffer, "mailboxbox%d", i+1);
		gtk_object_set_data(GTK_OBJECT(pb), buffer, box);
		ww = gnome_file_entry_new("execute",_("Browse"));
		gtk_box_pack_start(GTK_BOX(box),ww,TRUE,TRUE,0);
		mail_filename = gnome_file_entry_gtk_entry (GNOME_FILE_ENTRY (ww));
		gtk_entry_set_text(GTK_ENTRY(mail_filename), (gchar *) disp_info[i].mailbox_file);
		sprintf(buffer, "mailbox%d", i+1);
		gtk_object_set_data(GTK_OBJECT(pb), buffer, mail_filename);
		gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, 2, 3);
		gtk_table_attach_defaults(GTK_TABLE(mail_table), box,  1, 3, 2, 3);
		gtk_signal_connect(GTK_OBJECT(mail_filename), "changed",
			   GTK_SIGNAL_FUNC(changed_cb), pb);

		label = gtk_label_new(_("Execute"));
		entry = gtk_entry_new();
		gtk_entry_set_text(GTK_ENTRY(entry), (gchar *) disp_info[i].exec_command);
		sprintf(buffer, "exec%d", i+1);
		gtk_object_set_data(GTK_OBJECT(pb), buffer, entry);
		gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, 5, 6);
		gtk_table_attach_defaults(GTK_TABLE(mail_table), entry,  1, 3, 5, 6);
		gtk_signal_connect(GTK_OBJECT(entry), "changed",
			   GTK_SIGNAL_FUNC(changed_cb), pb);

		label = gtk_label_new(_("Count command"));
		entry = gtk_entry_new();
		gtk_entry_set_text(GTK_ENTRY(entry), (gchar *) disp_info[i].backend_command);
		sprintf(buffer, "backend%d", i+1);
		gtk_object_set_data(GTK_OBJECT(pb), buffer, entry);
		gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, 4, 5);
		gtk_table_attach_defaults(GTK_TABLE(mail_table), entry,  1, 3, 4, 5);
		gtk_signal_connect(GTK_OBJECT(entry), "changed",
			   GTK_SIGNAL_FUNC(changed_cb), pb);

		label = gtk_label_new(_("Counting"));
		gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, 3, 4);
		frame = gtk_hbox_new (FALSE, 0);
		sprintf(buffer, "countmodeframe%d", i+1);
		gtk_object_set_data(GTK_OBJECT(pb), buffer, frame);
		gtk_table_attach_defaults(GTK_TABLE(mail_table), frame, 1, 3, 3, 4);
		radio_table = gtk_table_new(1, 2, TRUE);
		gtk_container_add (GTK_CONTAINER (frame), radio_table);
		t_button = gtk_radio_button_new_with_label (NULL, _("Count unread messages"));
		sprintf(buffer, "unreadmessages%d", i+1);
		gtk_object_set_data(GTK_OBJECT(pb), buffer, t_button);
		gtk_table_attach(GTK_TABLE(radio_table), t_button, 0, 1, 0, 1,
       GTK_FILL | GTK_SHRINK, GTK_EXPAND | GTK_SHRINK, 0, 0);
		b_button = gtk_radio_button_new_with_label (gtk_radio_button_group (GTK_RADIO_BUTTON (t_button)), _("Count all messages"));
		gtk_table_attach(GTK_TABLE(radio_table), b_button, 1, 2, 0, 1,
       GTK_FILL | GTK_SHRINK, GTK_EXPAND | GTK_SHRINK, 0, 0);
		if(disp_info[i].show_all_messages)
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(b_button), TRUE);
		else
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(t_button), TRUE);
		gtk_signal_connect(GTK_OBJECT(t_button), "toggled",
			   GTK_SIGNAL_FUNC(changed_cb), pb);

		label = gtk_label_new(_("Mode"));
		gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, 1, 2);
		frame = gtk_hbox_new (FALSE, 0);
		gtk_table_attach_defaults(GTK_TABLE(mail_table), frame, 1, 3, 1, 2);
		radio_table = gtk_table_new(1, 2, TRUE);
		gtk_container_add (GTK_CONTAINER (frame), radio_table);
		t_button = gtk_radio_button_new_with_label (NULL, _("Mail"));
		sprintf(buffer, "mailmode%d", i+1);
		gtk_object_set_data(GTK_OBJECT(pb), buffer, t_button);
		gtk_table_attach(GTK_TABLE(radio_table), t_button, 0, 1, 0, 1,
       GTK_FILL | GTK_SHRINK, GTK_EXPAND | GTK_SHRINK, 0, 0);
		b_button = gtk_radio_button_new_with_label (gtk_radio_button_group (GTK_RADIO_BUTTON (t_button)), _("Command"));
		gtk_table_attach(GTK_TABLE(radio_table), b_button, 1, 2, 0, 1,
       GTK_FILL | GTK_SHRINK, GTK_EXPAND | GTK_SHRINK, 0, 0);
		if(disp_info[i].mail_mode)
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(t_button), TRUE);
		else
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(b_button), TRUE);
		gtk_signal_connect(GTK_OBJECT(t_button), "toggled",
			   GTK_SIGNAL_FUNC(toggle_countmode), (void *) i+1);

		/* Exec button */
		label = gtk_label_new(_("Label under counter"));
		gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, 8, 9);
		checkbox = gtk_check_button_new_with_label (_("On/Off"));
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbox), disp_info[i].exec_button);
//		gtk_widget_set_sensitive(displays2, disp_info[i].autodigits == 1 ? FALSE : TRUE);
		sprintf(buffer, "execbutton%d", i+1);
		gtk_object_set_data(GTK_OBJECT(pb), buffer, checkbox);
		gtk_table_attach_defaults(GTK_TABLE(mail_table), checkbox,  1, 2, 8, 9);

		gtk_signal_connect(GTK_OBJECT(checkbox), "toggled",
	                   	GTK_SIGNAL_FUNC(changed_cb), NULL);


		/* number of digits */
		adj = (GtkAdjustment *) gtk_adjustment_new(disp_info[i].digits, 1, MAX_DIGITS, 1, 1, 0);
		gtk_adjustment_set_value(adj, disp_info[i].digits);
		label = gtk_label_new(_("Number of digits"));
		displays2 = gtk_spin_button_new(adj, 0, 0);
		sprintf(buffer, "digits%d", i+1);
		gtk_object_set_data(GTK_OBJECT(pb), buffer, displays2);

		checkbox = gtk_check_button_new_with_label (_("Autorange"));
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbox), disp_info[i].autodigits);
		gtk_widget_set_sensitive(displays2, disp_info[i].autodigits == 1 ? FALSE : TRUE);
		sprintf(buffer, "autorange%d", i+1);
		gtk_object_set_data(GTK_OBJECT(pb), buffer, checkbox);
		gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, 6, 7);
		gtk_table_attach_defaults(GTK_TABLE(mail_table), displays2,  1, 2, 6, 7);
		gtk_table_attach_defaults(GTK_TABLE(mail_table), checkbox,  2, 3, 6, 7);

		gtk_signal_connect(GTK_OBJECT(checkbox), "toggled",
	                   	GTK_SIGNAL_FUNC(toggle_autorange), (void *)i+1);
		gtk_signal_connect(GTK_OBJECT(displays2), "changed",
	                   	GTK_SIGNAL_FUNC(changed_cb), NULL);
		gtk_signal_connect(GTK_OBJECT(adj), "value_changed",
	                   	GTK_SIGNAL_FUNC(changed_cb), NULL);

		/* Update */
		adj = (GtkAdjustment *) gtk_adjustment_new(0, 100, 1000000, 1000, 100, 0);
		gtk_adjustment_set_value(adj, disp_info[i].updatetime);
		label = gtk_label_new(_("Update (ms)"));
		update = gtk_spin_button_new(adj, 0, 0);
		sprintf(buffer, "update%d", i+1);
		gtk_object_set_data(GTK_OBJECT(pb), buffer, update);
		gtk_table_attach_defaults(GTK_TABLE(mail_table), label, 0, 1, 7, 8);
		gtk_table_attach_defaults(GTK_TABLE(mail_table), update,  1, 2, 7, 8);

		gtk_signal_connect(GTK_OBJECT(adj), "changed",
	                   	GTK_SIGNAL_FUNC(changed_cb), NULL);
		gtk_signal_connect(GTK_OBJECT(adj), "value_changed",
	                   	GTK_SIGNAL_FUNC(changed_cb), NULL);

		sprintf(buffer, _("Display %d"), i+1);
		gnome_property_box_append_page(GNOME_PROPERTY_BOX(pb), mail_table,
				       gtk_label_new(buffer));
	}

	gtk_signal_connect(GTK_OBJECT(pb), "apply",
                           GTK_SIGNAL_FUNC(apply_cb), pb);
	gtk_signal_connect(GTK_OBJECT(pb), "destroy",
                           GTK_SIGNAL_FUNC(gtk_widget_destroyed),&pb);

	gtk_widget_show_all(pb);
}
